/*
Provides a Vue 3 component that allows the user to enter a 
Bear Necessities Market ID number (9 alphanumeric characters). 
The ID number can be entered manually, or with a barcode scanner.
Emits a sendIDEvent with the ID.
*/

<template>
    <div class="container">
        <input class="guestIdField" placeholder="Guest ID" v-model="idNum" 
            @keypress.prevent @keyup="idNumChange"
            autofocus="autofocus" />
        <button class="submit" :disabled="!submitEnable" 
            @click="onClickSubmit()">Add guest / record visit</button>
    </div>
</template>
<script>

// Function ensures input is a number or letter and nothing else
function isCleanInput(key) {
    return (key >= 48 && key <= 57) || (key >= 65 && key <= 90);
}

export default {
    name: "IdInputComponent",
    emits: [
        'sendIDEvent'
    ],
    data() {
        return {
            idNum: '',
            idInputMode: 'manual',
            swipeZerosSeen: 0,
            submitEnable: false,
        }
    },
    props: {
        idNumber: String
    },
    watch: {
        idNumber() {
            this.idNum = this.idNumber;
        }
    },
    methods: {
        idNumChange(e) {
            // Disables submit button if all nine characters have not been entered
            if (this.idNum.length < 9) {
                this.submitEnable = false;
            }
            
            // Accept nine alphanumeric characters
            this.acceptDigits(e.keyCode);
            // Enter key (keycode 13) will perform same function as clicking submit button
            // Scanner automatically appends enter keycode to end of scan
            if (e.keyCode === 13 && this.idNum.length === 9) {
                this.onClickSubmit();
            }
        },
        // Accepts characters until nine are entered, then enables submit button
        acceptDigits(key) {
            if (this.idNum.length < 9 && isCleanInput(key)) {
                this.idNum = this.idNum + String.fromCharCode(key);
                if (this.idNum.length === 9) {
                    this.submitEnable = true;
                    this.idInputMode = "manual";
                }
            }
        },
        onClickSubmit() {
            this.$emit('sendIdEvent', this.idNum);
        },
    }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.guestIdField {
    min-height: 5vh;
    min-width: 20vw;
    max-width: 25vw;
    margin: 0 10px 10px 0;
    font-size: 20px;
    color: black;
}
</style>
